#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <linux/input.h>

#include <android/log.h>
#define LOG_TAG "show infomation"
#define LOGW(a )  __android_log_write(ANDROID_LOG_WARN,LOG_TAG,a)

#define EVKKEY_DEV "/dev/input/event1"
#define BACKLIGHT_DEV "/sys/class/backlight/pwm-backlight.0/brightness"
#define GPIOKEY_DEV "/dev/input/event0"


static int ts_fd = -1;
static struct input_event data;
static int savedBrightness = 30;

int sendevent(char* device,int type, int code,int value)
{
    int i;
    int fd;
    int ret;
    struct input_event event;
    char eventmsg[10];
    struct timeval tv;

    tv.tv_sec = 0;
    tv.tv_usec = 2*1000;
    select (0, NULL, NULL, NULL, &tv);  
//    LOGW("sleep for 2 ms before sending event.");

    fd = open(device, O_RDWR);
    if(fd < 0) {
        LOGW("Error open ");
        LOGW(device);
        LOGW("\n");
        return -1;
    }
    memset(&event, 0, sizeof(event));
    event.type = type;
    event.code = code;
    event.value = value;
    gettimeofday(&(event.time), NULL);
    ret = write(fd, &event, sizeof(event));
    close(fd);
    if(ret < sizeof(event)) {
        LOGW("write event failed");
        LOGW("\n");
        close(fd);
        return -1;
    }

    return 0;
}

int switchLcdBacklight()
{
    int i;
    int fd;
    int ret;
    char brightness[10];
    int currentBrightness;

    memset(brightness,0,10);


    fd = open(BACKLIGHT_DEV, O_RDWR);
    if(fd < 0) {
        LOGW("Error open ");
        LOGW(BACKLIGHT_DEV);
        LOGW("\n");
        return -1;
    }
    read(fd,brightness,9);
    currentBrightness = atoi(brightness);
    if(currentBrightness == 0)
    {
      sprintf(brightness,"%d",savedBrightness);
      ret = write(fd, brightness, strlen(brightness));
    }
    else
    {
      savedBrightness = currentBrightness;
      sprintf(brightness,"%d",0);
      ret = write(fd, brightness, strlen(brightness));

    }
    
    close(fd);

    return 0;
}

int turnOnLcdBacklight()
{
    int i;
    int fd;
    int ret;
    char brightness[10];
    int currentBrightness;

    memset(brightness,0,10);


    fd = open(BACKLIGHT_DEV, O_RDWR);
    if(fd < 0) {
        LOGW("Error open ");
        LOGW(BACKLIGHT_DEV);
        LOGW("\n");
        return -1;
    }
    sprintf(brightness,"%d",savedBrightness);
    ret = write(fd, brightness, strlen(brightness));
    
    close(fd);

    return 0;
}

int init_device(char *TS_DEV)
{
    if((ts_fd = open(TS_DEV, O_RDONLY)) < 0)
    {
        LOGW("Error open ");
        LOGW(TS_DEV);
        LOGW("\n");
        return -1;
    }
    return ts_fd;
}

int usePageKeys()
{
  return 1;
}

 int listento_evkkey()
{
    int i = 0;
    struct timeval tvLastAppSwitcherPress;
    struct timeval tvNow;
    if(init_device(EVKKEY_DEV) < 0)
        return -1;

    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        if (data.type == EV_KEY && data.code == 183 && data.value == 1) /*it's an app switcher key press*/
        {
          switchLcdBacklight();
        }
        else if(data.type == EV_KEY && data.code == 183 && data.value == 100)
        {
        /*    system("sendevent /dev/input/event1 1 183 0");*/
            close(ts_fd);            
            return 0;
        }
        
        else if(data.type == EV_KEY && data.code == 109)
        {
            LOGW("next page key pressed.\n");
                      
            sendevent(GPIOKEY_DEV,EV_KEY,114,data.value);  /*volume down*/
        }
        else if(data.type == EV_KEY && data.code == 104)
        {
            LOGW("previous page key pressed.\n");

            sendevent(GPIOKEY_DEV,EV_KEY,115,data.value); /*volume up*/
        }      
        
    }
    close(ts_fd);
    return 0;
}

int main()
{
   listento_evkkey();
   turnOnLcdBacklight();
   LOGW("evklistener exit.\n");
   return 0;
}