#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <linux/input.h>
#define TABLET_DEV "/dev/input/event4"
#define WACOM_DEV "/dev/input/event6"
#define GPIOKEY_DEV "/dev/input/event0"
#define EVKKEY_DEV "/dev/input/event1"
#define PXAKEY_DEV "/dev/input/event2"

static int ts_fd = -1;
static struct input_event data;

static int init_device(char *TS_DEV)
{
    if((ts_fd = open(TS_DEV, O_RDONLY)) < 0)
    {
        printf("Error open %s\n\n", TS_DEV);
        return -1;
    }
    return ts_fd;
}


static int test_wacom()
{
    if(init_device(WACOM_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        printf("%d,%d,%d\n",data.type,data.code,data.value);

        if (data.type == EV_KEY)
        {
            printf("  type: EV_KEY, event = %s, value = %d\n\n",
                data.code == BTN_TOUCH ? "BTN_TOUCH" : "Unkown", data.value);
        }
        else if(data.type == EV_ABS)
        {
            printf("  type: EV_ABS, event = %s, value = %d\n\n",
                data.code == ABS_X ? "ABS_X" :
                data.code == ABS_Y ? "ABS_Y" :
                data.code == ABS_PRESSURE ? "ABS_PRESSURE" :
                "Unkown", data.value);
        }
        else if(data.type == EV_REL)
        {
            printf("  type = EV_REL, code = %s, value = %d\n",
                data.code == REL_X ? "REL_X" :
                data.code == REL_Y ? "REL_Y" :
                data.code == ABS_WHEEL ? "MOUSE_WHEEL" :
                data.code == ABS_PRESSURE ? "ABS_PRESSURE" :
                "Unkown", data.value);
        }
    }
    return 0;
}

static int test_tablet()
{
    if(init_device(TABLET_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        printf("%d,%d,%d\n",data.type,data.code,data.value);

        if (data.type == EV_KEY)
        {
            printf("  type: EV_KEY, event = %s, value = %d\n\n",
                data.code == BTN_TOUCH ? "BTN_TOUCH" : "Unkown", data.value);
        }
        else if(data.type == EV_ABS)
        {
            printf("  type: EV_ABS, event = %s, value = %d\n\n",
                data.code == ABS_X ? "ABS_X" :
                data.code == ABS_Y ? "ABS_Y" :
                data.code == ABS_PRESSURE ? "ABS_PRESSURE" :
                "Unkown", data.value);
        }
        else if(data.type == EV_REL)
        {
            printf("  type = EV_REL, code = %s, value = %d\n",
                data.code == REL_X ? "REL_X" :
                data.code == REL_Y ? "REL_Y" :
                data.code == ABS_WHEEL ? "MOUSE_WHEEL" :
                data.code == ABS_PRESSURE ? "ABS_PRESSURE" :
                "Unkown", data.value);
        }
    }
    return 0;
}


static int test_touch_pancel()
{
    if(init_device(WACOM_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        if (data.type == EV_KEY)
        {
            printf("  type = EV_KEY, code = %s, value = %d\n",
                data.code == BTN_LEFT ? "MOUSE_LEFT" :
                data.code == BTN_RIGHT ? "MOUSE_RIGHT" :
                data.code == BTN_MIDDLE ? "MOUSE_MIDDLE" :
                data.code == BTN_SIDE ? "MOUSE_SIDE" :
                "Unkonw", data.value);
        }
        else if(data.type == EV_REL)
        {
            printf("  type = EV_REL, code = %s, value = %d\n",
                data.code == REL_X ? "REL_X" :
                data.code == REL_Y ? "REL_Y" :
                data.code == ABS_WHEEL ? "MOUSE_WHEEL" :
                data.code == ABS_PRESSURE ? "ABS_PRESSURE" :
                "Unkown", data.value);
        }
    }
    return 0;
}

static int test_gpiokey()
{
    if(init_device(GPIOKEY_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        if (data.type == EV_KEY)
            printf("  type: EV_KEY, event = %d, value = %d\n",data.code, data.value);
    }
    return 0;
}

static int test_evkkey()
{
    if(init_device(EVKKEY_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        if (data.type == EV_KEY)
            printf("  type: EV_KEY, event = %d, value = %d\n",data.code, data.value);
    }
    return 0;
}

static int test_pxakey()
{
    if(init_device(PXAKEY_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        if (data.type == EV_KEY)
            printf("  type: EV_KEY, event = %d, value = %d\n",data.code, data.value);
    }
    return 0;
}

int main()
{
    static int i;
select:    printf("Please select device:\n0.wacom\n1.tablet\n2.gpio key\n3.evk key\n4.pxa key\n");
    scanf("%d",&i);
    switch(i){
        case 0:
            test_wacom();
            break;
        case 1:
            test_tablet();
            break;
        case 2:
            test_gpiokey();
            break;
        case 3:
            test_evkkey();
            break;
        case 4:
            test_pxakey();
            break;
        default:
            printf("Wrong device, Please select again!\n\n");
            break;       
    }
    goto select;
        return 0;
}