#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/fb.h>
#include <linux/input.h>


#include <android/log.h>
#define LOG_TAG "show infomation"
#define LOGW(a )  __android_log_write(ANDROID_LOG_WARN,LOG_TAG,a)

int gfd_eink;
void *gfb_mem_eink;
unsigned long fb_mem_offset;

static struct fb_var_screeninfo vi;
struct fb_fix_screeninfo fi;

int gfd_lcd;
void *gfb_mem_lcd;

static struct fb_var_screeninfo vi_lcd;
struct fb_fix_screeninfo fi_lcd;






int main(int argc,char *argv[])
{

    uint8_t color8;
    uint16_t color16;
    int x,y;
    int i;
    int j = 0;
    uint8_t color8_static = 0;
    uint8_t * buffer=NULL;

    struct timeval tv;
    char logbuf[100];

    tv.tv_sec = 0;
    tv.tv_usec = 300*1000;

    gfd_eink = open("/dev/graphics/fb2", O_RDWR);
    if(gfd_eink < 0) {
        LOGW("cannot open fb2");
        return -1;
    }

    if(ioctl(gfd_eink, FBIOGET_FSCREENINFO, &fi) < 0) {
        LOGW("failed to get fb2 info");
        close(gfd_eink);
        return -1;
    }

    if(ioctl(gfd_eink, FBIOGET_VSCREENINFO, &vi) < 0) {
        LOGW("failed to get fb2 info");
        close(gfd_eink);
        return -1;
    }

    //dumpinfo(&fi, &vi);
    fb_mem_offset = (unsigned long)(fi.smem_start) & (~PAGE_MASK);
    gfb_mem_eink = mmap(0, fi.smem_len+fb_mem_offset, PROT_READ | PROT_WRITE, MAP_SHARED, gfd_eink, 0);
    if(gfb_mem_eink == MAP_FAILED) {
        
        LOGW("failed to mmap framebuffer");
        close(gfd_eink);
        return -1;
    }
  	

    if(1)
    {
      gfd_lcd = open("/dev/graphics/fb0", O_RDWR);
      if(gfd_lcd < 0) {
          LOGW("cannot open fb0");
          return -1;
      }

      if(ioctl(gfd_lcd, FBIOGET_FSCREENINFO, &fi_lcd) < 0) {
          LOGW("failed to get fb0 info");
          close(gfd_lcd);
          return -1;
      }

      if(ioctl(gfd_lcd, FBIOGET_VSCREENINFO, &vi_lcd) < 0) {
          LOGW("failed to get fb0 info");
          close(gfd_lcd);
          return -1;
      }

      //dumpinfo(&fi, &vi);

      gfb_mem_lcd = mmap(0, fi_lcd.smem_len, PROT_READ | PROT_WRITE, MAP_SHARED, gfd_lcd, 0);
      if(gfb_mem_lcd == MAP_FAILED) {
        
          LOGW("failed to mmap framebuffer");
          close(gfd_lcd);
          return -1;
      }
	  
     buffer = (uint8_t *)malloc(fi.smem_len); 
     if(buffer == NULL)
     {
       close(gfd_lcd);
       close(gfd_eink);
       return -1;
     }
     memset(buffer,0xFF,fi.smem_len);

     
      for(i = 0;i<vi_lcd.yres*vi_lcd.xres;i++)
      {
          y = i%vi_lcd.xres;
          x = vi_lcd.yres-i/vi_lcd.xres+60;
          color16 = ((uint16_t*)gfb_mem_lcd)[i];
          color8 = (color16*255.0)/65535;
          *(buffer+vi.xres*y+x) = color8;
      }
      
      memcpy((uint8_t *) gfb_mem_eink,buffer,fi.smem_len);
      free(buffer);
      //memset((uint8_t *)gfb_mem_eink+fb_mem_offset,0xff,fi.smem_len);


/*
      switch(argv[1][0])
      {
        case '0':

            for(i = 0;i<vi_lcd.yres*vi_lcd.xres;i++)
            {
              y = i%vi_lcd.xres;
              x = vi_lcd.yres-i/vi_lcd.xres;
              color16 = ((uint16_t*)gfb_mem_lcd)[i];
              color8 = (color16*255.0)/65535;
              memset((uint8_t *)gfb_mem_eink+fb_mem_offset+vi.xres*y+x,color8,1);
            }
          break;

        case '1':

          for(i = 0;i<vi_lcd.yres*vi_lcd.xres/3;i++)
          {
            y = i%vi_lcd.xres;
            x = vi_lcd.yres-i/vi_lcd.xres;
            color16 = ((uint16_t*)gfb_mem_lcd)[i];
            color8 = (color16*255.0)/65535;
            memset((uint8_t *)gfb_mem_eink+fb_mem_offset+vi.xres*y+x,color8,1);
          }
          break;

        case '2':
              memset((uint8_t *)gfb_mem_eink+fb_mem_offset,0,vi.xres*vi.yres);

            if(color8_static == 0)
              color8_static = 1;
            else
              color8_static = 0;
          
            for(i = 0;i<vi_lcd.yres*vi_lcd.xres;i++)
            {
              y = i%vi_lcd.xres;
              x = vi_lcd.yres-i/vi_lcd.xres;
              color16 = ((uint16_t*)gfb_mem_lcd)[i];
              color8 = (color16*255.0)/65535;
            }
          break;
        case '3':
              memset((uint8_t *)gfb_mem_eink+fb_mem_offset,1,vi.xres*vi.yres);

            if(color8_static == 0)
              color8_static = 1;
            else
              color8_static = 0;
          
            for(i = 0;i<vi_lcd.yres*vi_lcd.xres;i++)
            {
              y = i%vi_lcd.xres;
              x = vi_lcd.yres-i/vi_lcd.xres;
              color16 = ((uint16_t*)gfb_mem_lcd)[i];
              color8 = (color16*255.0)/65535;
            }
          break;

          
        default:
          break;
      }
      */
      close(gfd_lcd);
    }  

   close(gfd_eink);
   return 0;
}