#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/fb.h>
#include <linux/input.h>


#include <android/log.h>
#define LOG_TAG "show infomation"
#define LOGW(a )  __android_log_write(ANDROID_LOG_WARN,LOG_TAG,a)

#define WACOM_DEV "/dev/input/event6"


static int ts_fd = -1;
static struct input_event data;
int wacomStartX = 0;
int wacomStartY = 0;
int wacomEndX = 800;
int wacomEndY = 600;

int gfd_eink;
void *gfb_mem_eink;

static struct fb_var_screeninfo vi;
struct fb_fix_screeninfo fi;




int drawEinkPoint(int x, int y,int pressure)
{
    memset(gfb_mem_eink+y*vi.xres+x, 0, 1);
    return 0;
}



static int init_device(char *TS_DEV)
{
    if((ts_fd = open(TS_DEV, O_RDONLY)) < 0)
    {
        LOGW("Error open ");
        LOGW(TS_DEV);
        LOGW("\n");
        return -1;
    }
    return ts_fd;
}


static int listento_wacom()
{
    int i = 0;
    static int type,code,value;
    int x,y;


    if(init_device(WACOM_DEV) < 0)
        return -1;
    while(1)
    {
        read(ts_fd, &data, sizeof(data));
        type = data.type;
        code = data.code;
        value = data.value;

        if(data.type == 3 && data.code == 0 && data.value == 99999)
        {
            close(ts_fd);            
            return 0;
        }

        if(data.type == 3 && data.code == 0) /*abs,x should be mapped to abs,y*/
        {
          code = 1;
          y = (data.value-wacomStartX)*(vi.yres)/(wacomEndX-wacomStartX)+vi.xres;
          drawEinkPoint(x,y,value);
        }
        else if(data.type == 3 && data.code == 1) /*abs,y should be mapped to abs,x*/
        {
          code = 0;
          x = vi.xres-(value-wacomStartY)*(vi.xres)/(wacomEndY-wacomStartY);
          drawEinkPoint(x,y,value);
        }
        else if(data.type == 3 && data.code == 24) /*abs,pressure level */
        {
          drawEinkPoint(x,y,value);
        }
        else if(data.code == 272) /*wacom abs,272 should be mapped to abs,BTN_TOUCH*/
        {
          code = BTN_TOUCH;
        }

    }
    close(ts_fd);
    return 0;
}

int main()
{

    gfd_eink = open("/dev/graphics/fb2", O_RDWR);
    if(gfd_eink < 0) {
        LOGW("cannot open fb2");
        return -1;
    }

    if(ioctl(gfd_eink, FBIOGET_FSCREENINFO, &fi) < 0) {
        LOGW("failed to get fb2 info");
        return -1;
    }

    if(ioctl(gfd_eink, FBIOGET_VSCREENINFO, &vi) < 0) {
        LOGW("failed to get fb2 info");
        return -1;
    }

    //dumpinfo(&fi, &vi);

    gfb_mem_eink = mmap(0, fi.smem_len, PROT_READ | PROT_WRITE, MAP_SHARED, gfd_eink, 0);
    if(gfb_mem_eink == MAP_FAILED) {
        LOGW("failed to mmap framebuffer");
        return -1;
    }
	
   memset(gfb_mem_eink, 0xff, fi.smem_len);

   listento_wacom();
   LOGW("wacomlistener exit.\n");
   close(gfd_eink);
   return 0;
}