#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <unistd.h>


#define MAXLINE 80
#define SERV_PORT 32007

void do_cli(FILE *fp, int sockfd, struct sockaddr *pservaddr, socklen_t servlen)
{
size_t result;
long lSize;
char * buffer;


/* connect to server */
if(connect(sockfd, (struct sockaddr *)pservaddr, servlen) == -1)
{
perror("connect error");
exit(1);
}

fseek (fp , 0 , SEEK_END);
lSize = ftell (fp);
rewind (fp);

printf("file size %d\n",lSize);
// allocate memory to contain the whole file:
buffer = (char*) malloc (sizeof(char)*lSize);
if (buffer == NULL) 
{
  fputs ("Memory error",stderr); 
  fclose(fp);
  close(sockfd);
  exit (2);
}

result = fread (buffer,1,lSize,fp);
if (result != lSize) 
{
  fputs ("Reading error",stderr); 
  fclose(fp);
  close(sockfd);
  free(buffer);
  exit (3);
}

write(sockfd, buffer, lSize);
/* receive data from server */
fclose(fp);
close(sockfd);
free(buffer);
}

int main(int argc, char **argv)
{
int sockfd;
struct sockaddr_in servaddr;
FILE  *AStream;

/* check args */
if(argc != 2)
{
printf("usage: udpclient <filename>\n");
exit(1);
}

/* init servaddr */
bzero(&servaddr, sizeof(servaddr));
servaddr.sin_family = AF_INET;
servaddr.sin_port = htons(SERV_PORT);

inet_pton(AF_INET, "127.0.0.1", &servaddr.sin_addr);



sockfd = socket(AF_INET, SOCK_DGRAM, 0);

AStream=fopen(argv[1],"rb");
if(AStream == NULL)
{
   printf("failed to open file %s\n",argv[1]);
   close(sockfd);
}

do_cli(AStream, sockfd, (struct sockaddr *)&servaddr, sizeof(servaddr));

return 0;
}